#ifndef M078CKA_H_
#define M078CKA_H_

//#include "stdafx.h"
#include <avr/io.h>

// declarations from stdafx.h
extern const unsigned short int DEFAULT_DELAY;
extern void delayMs( unsigned int ms );

// declarations from uartSparse.h
extern void uartSendSZ(char* chars);
extern void uartSendChar(const char character);
extern void uartSendByteHex(const short int byteValue);


/*
 *  Driver for LC-Display Sharp M078C-A3QKLA0057
 */


/* 
 * Pin assignments to AT90S2313:
 */

#define RESB PD2	//low-active
#define CSB  PD3 	//low-active
#define RS   PD4 	//low: Data, high: Control
#define WRB  PD5 	//low-active
#define RDB  PD6 	//low-active
//#define PD7  7   	//virtual - there is no pin for PD7
//#define RE   PD7

void lcdInit();
void lcdCommandWrite(const unsigned short int data);
void lcdExtendedFunction(unsigned short int selectExtendedFunction);
void lcdSetRegisterReadAddress(const unsigned short int readAddress);
unsigned short int lcdRegisterRead();
void lcdDataWrite(const unsigned short int ramData);
unsigned short int lcdDataRead();

//void lcdSetReadAdress(const char adress);
//char lcdRead();

#endif /*M078CKA_H_*/
